//+------------------------------------------------------------------+
//+ Thank you Ronald Reygun for the base code!                      +
//+ This EA is primarily intended for BreakOut strategies.           +
//+ Can be used for Swing Trading.                                   +
//+ It should be monitored, it is just a tool to help traders.       +
//+------------------------------------------------------------------+
//+                                                                  +
//+   USE AT YOUR OWN RISK. AUTHOR IS IN NO WAY RESPONSIBLE FOR ANY  +
//+   LOSSES NOR GAINS, IF USED ON ACCOUNTS WITH REAL MONEY, NOR ANY +
//+   OTHER ACCOUNTS. SHOULD NOT BE USED AT ALL!                     +
//+                                                                  +
//+   FOR EDUCATIONAL AND INFORMATIONAL USE ONLY!                    +
//+------------------------------------------------------------------+
/*
banking_profit.wav
bells_train_crossing.wav
cha_ching.wav
church_bells.wav
horn_1.wav
siren_1.wav
siren_2.wav
slot_machine.wav
*/
#include <CommonFunctionsChi.mqh>
//#include <offline_charts.mqh> 

#define           SIGNAL_NONE             0
#define           SIGNAL_BUY              1
#define           SIGNAL_SELL             2

#property copyright  "Copyright@2010, Chistabo"
#property link       "chistabo@gmail.com"

extern string     Note1                   = "== Main Settings ==";
extern bool       SignalsOnly             = false;
extern int        MaxTrades               = 3;
extern bool       ContinueTrading         = true;
extern bool       EachTickMode            = True;
extern bool       Alerts                  = false;
extern bool       PlaySounds              = false;
extern string     WhichSound              = "tick.wav";

extern string     Note2                   = "== Money Management ==";
extern double     Lots                    = 0.01;                       // lots to use if MoneyManagement is False
extern bool       MoneyManagement         = true;                      
extern double     Risk                    = 0.3;
extern int        Slippage                = 50;

extern string     Note4                   = "== HiLo SL Settings ==";
extern int        StopLossTF              = 5;
extern int        StopLossBarsBack        = 1;
extern int        StopLossPipsFromHiLo    = 60;

extern string     Note7                   = "== Move SL once Settings ==";
extern bool       MoveStopOnce            = false;
extern int        MoveStopWhenPrice       = 150;
extern int        MoveStopTo              = 30;

extern string     Note8                   = "== Trail Settings ==";
extern bool       UseTrailHiLoStop        = false;
extern int        TrailBarTF              = 240;
extern int        TrailBarsBack           = 3;
extern int        TrailPipsFromHiLo       = 0;

extern string     Note9                   = "== Filter TF Settings Open ==";
extern int        FilterBarTF             = 1;

extern string     Note10                  = "== Signal TF Settings HiLo ==";
extern int        SignalBarTF             = 1;

extern string     Note11                 = "== Trade Once Per Bar Settings ==";
extern int        OncePerBarTF            = 1;

extern string     Note12                  = "== Trading hours are Broker time ==";
extern int        StartTrading            = 0;
extern int        StopTrading             = 24;

double            BuyTS, SellTS, Spread, SwapBuy, SwapSell, TickValue, BuySL, SellSL;
int               BarCount, Current, Err, MagicNo;
datetime          CheckAlertTime;
bool              TickCheck               = False;
string            name                    = "7Chi";
//bool              BuyOnly                 = false;
//bool              SellOnly                = false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() 
   {
   if (!IsDemo()) GlobalVariableSet ("SignalsOnly_" + Symbol(), 1); //SignalsOnly = true;
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;
   MagicNo = MakeMagicNumber (WindowExpertName() + Symbol());
   
   if (!GlobalVariableCheck ("SignalsOnly_" + Symbol())) GlobalVariableSet ("SignalsOnly_" + Symbol(), BoolToInt (SignalsOnly));
   if (!GlobalVariableCheck ("Continue_" + Symbol())) GlobalVariableSet ("Continue_" + Symbol(), BoolToInt (ContinueTrading));
 //  if (!GlobalVariableCheck ("BuyOnly_" + Symbol())) GlobalVariableSet ("BuyOnly_" + Symbol(), BuyOnly);
 //  if (!GlobalVariableCheck ("SellOnly_" + Symbol())) GlobalVariableSet ("SellOnly_" + Symbol(), SellOnly);

   Comment (
   "Trading Hours: ", StartTrading, " to ", StopTrading, " | Max Trades: ", MaxTrades, " | SIGNALS ONLY: ", BoolToStr2 (SignalsOnly), "\n",
   "Filter | Signal TF: ", FilterBarTF, " | ", SignalBarTF, " | TPerBar: ", OncePerBarTF, " | Continue Trading: ", BoolToStr2 (ContinueTrading), "\n",
   "SL: TF: ", StopLossTF, " | Bars Back: ", StopLossBarsBack, " | Pips from HiLo: ", StopLossPipsFromHiLo, "\n",
   "HiLo TS: ", BoolToStr (UseTrailHiLoStop), " | TF: ", TrailBarTF, " | Bars Back: ", TrailBarsBack, " | Pips from HiLo: ", TrailPipsFromHiLo, "\n",
   "BE: ", BoolToStr (MoveStopOnce), " | When ", MoveStopWhenPrice, " | To ", MoveStopTo, "\n",
   "Auto MM: ",  BoolToStr (MoneyManagement), " | Risk: ", Risk, " | Lots: ", Lots, "\n",
   "Magic: ", MagicNo, " | P/L: ", NormalizeDouble (GetProfit (MagicNo), 2), " | Closed Profit: ", NormalizeDouble (GetClosedProfit (MagicNo), 2), " | Equity: ", NormalizeDouble (AccountEquity(), 2), "\n"
            );
   }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
   {
   if (!IsTesting())
      {
      Comment ("");
      }
   if (!IsDemo())
      {
      GlobalVariableSet ("SignalsOnly_" + Symbol(), 1);
      }
   ObjectDelete ("SignalsOnly"); ObjectDelete ("CloseAll"); ObjectDelete ("CloseBuy"); ObjectDelete ("CloseSell"); ObjectDelete ("Continue");
   return(0);
   }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() 
   {
   Comment (
   "Trading Hours: ", StartTrading, " to ", StopTrading, " | Max Trades: ", MaxTrades, " | SIGNALS ONLY: ", BoolToStr2 (SignalsOnly), "\n",
   "Filter | Signal TF: ", FilterBarTF, " | ", SignalBarTF, " | TPerBar: ", OncePerBarTF, " | Continue Trading: ", BoolToStr2 (ContinueTrading), "\n",
   "SL: TF: ", StopLossTF, " | Bars Back: ", StopLossBarsBack, " | Pips from HiLo: ", StopLossPipsFromHiLo, "\n",
   "HiLo TS: ", BoolToStr (UseTrailHiLoStop), " | TF: ", TrailBarTF, " | Bars Back: ", TrailBarsBack, " | Pips from HiLo: ", TrailPipsFromHiLo, "\n",
   "BE: ", BoolToStr (MoveStopOnce), " | When ", MoveStopWhenPrice, " | To ", MoveStopTo, "\n",
   "Auto MM: ",  BoolToStr (MoneyManagement), " | Risk: ", Risk, " | Lots: ", Lots, "\n",
   "Magic: ", MagicNo, " | P/L: ", NormalizeDouble (GetProfit (MagicNo), 2), " | Closed Profit: ", NormalizeDouble (GetClosedProfit (MagicNo), 2), " | Equity: ", NormalizeDouble (AccountEquity(), 2), "\n"
            );
//--------------------------------------------------------------------------------
//   GlobalVariableGet ("SignalsOnly_" + Symbol());

//   recordEquity (name + " " + Symbol(), PERIOD_H1, MagicNo);
   checkLines();
   CheckMaxTrades();
   if (!IsTesting())
      {
      plotNewOpenTrades(MagicNo);
      plotNewClosedTrades(MagicNo);
      }
/*   if (BuyOnly && SellOnly)
      {
      Print ("Buy / Sell Only mismatch!"); Alert ("Buy / Sell Only mismatch!");
      GlobalVariableSet ("BuyOnly", 0); GlobalVariableSet ("SellOnly", 0);
      }
*/
//---------- SIGNALS ONLY BUTTON FUNCTION
   if (ObjectFind ("SignalsOnly") == -1)
      {
      ObjectCreate ("SignalsOnly", OBJ_LABEL, 0, 0, 0);
      ObjectSet ("SignalsOnly", OBJPROP_CORNER, 1);
      ObjectSet ("SignalsOnly", OBJPROP_XDISTANCE, 10);
      ObjectSet ("SignalsOnly", OBJPROP_YDISTANCE, 15);
      }
   ObjectSetText ("SignalsOnly", "[TRADE]", 10, "Arial", CLR_NONE);

   if (ObjectFind ("SignalsOnly") != -1 && ObjectGet ("SignalsOnly", OBJPROP_XDISTANCE)!= 10)
      {
      ObjectDelete ("SignalsOnly");
      if (SignalsOnly)
         {
         GlobalVariableSet ("SignalsOnly_" + Symbol(), 0); // SignalsOnly = false;
         }
      else 
         {
         GlobalVariableSet ("SignalsOnly_" + Symbol(), 1); // SignalsOnly = true;
         }
      }

   if (GlobalVariableGet ("SignalsOnly_" + Symbol()) == 1) SignalsOnly = true;
   if (GlobalVariableGet ("SignalsOnly_" + Symbol()) == 0) SignalsOnly = false;

   if (SignalsOnly) ObjectSetText ("SignalsOnly", "[TRADE]", 10, "Arial", Lime);
   if (!SignalsOnly) ObjectSetText ("SignalsOnly", "[TRADE]", 10, "Arial", Red);
//---------- CONTINUE BUTTON FUNCTION
   if (ObjectFind ("Continue") == -1)
      {
      ObjectCreate ("Continue", OBJ_LABEL, 0, 0, 0);
      ObjectSet ("Continue", OBJPROP_CORNER, 1);
      ObjectSet ("Continue", OBJPROP_XDISTANCE, 10);
      ObjectSet ("Continue", OBJPROP_YDISTANCE, 35);
      }
   ObjectSetText ("Continue", "[CONTINUE]", 10, "Arial", CLR_NONE);

   if (ObjectFind ("Continue") != -1 && ObjectGet ("Continue", OBJPROP_XDISTANCE)!= 10)
      {
      ObjectDelete ("Continue");
      if (ContinueTrading)
         {
         GlobalVariableSet ("Continue_" + Symbol(), 0); // continue set to false
         }
      else 
         {
         GlobalVariableSet ("Continue_" + Symbol(), 1); // continue set to true
         }
      }

   if (GlobalVariableGet ("Continue_" + Symbol()) == 1) ContinueTrading = true;
   if (GlobalVariableGet ("Continue_" + Symbol()) == 0) ContinueTrading = false;

   if (ContinueTrading) ObjectSetText ("Continue", "[CONTINUE]", 10, "Arial", Green);
   if (!ContinueTrading) ObjectSetText ("Continue", "[CONTINUE]", 10, "Arial", C'31,31,31');
//----- CLOSE ALL BUTTON FUNKCION
   if (ObjectFind ("CloseAll") == -1 )
      {
      ObjectCreate ("CloseAll", OBJ_LABEL, 0, 0, 0);
      ObjectSet ("CloseAll", OBJPROP_CORNER, 1);
      ObjectSet ("CloseAll", OBJPROP_XDISTANCE, 10);
      ObjectSet ("CloseAll", OBJPROP_YDISTANCE, 55);
      }
   ObjectSetText ("CloseAll", "[CLOSE ALL]", 10, "Arial", White);

   if (ObjectFind ("CloseAll") != -1 && ObjectGet ("CloseAll", OBJPROP_XDISTANCE)!= 10)
      {
      CloseAll();
      ObjectDelete ("CloseAll");
      }
//----- CLOSE BUY BUTTON FUNKCION
   if (ObjectFind ("CloseBuy") == -1 )
      {
      ObjectCreate ("CloseBuy", OBJ_LABEL, 0, 0, 0);
      ObjectSet ("CloseBuy", OBJPROP_CORNER, 1);
      ObjectSet ("CloseBuy", OBJPROP_XDISTANCE, 10);
      ObjectSet ("CloseBuy", OBJPROP_YDISTANCE, 75);
      }
   ObjectSetText ("CloseBuy", "[CLOSE BUY]", 10, "Arial", Blue);

   if (ObjectFind ("CloseBuy") != -1 && ObjectGet ("CloseBuy", OBJPROP_XDISTANCE)!= 10)
      {
      CloseBuy();
      ObjectDelete ("CloseBuy");
      }
//----- CLOSE SELL BUTTON FUNKCION
   if (ObjectFind ("CloseSell") == -1 )
      {
      ObjectCreate ("CloseSell", OBJ_LABEL, 0, 0, 0);
      ObjectSet ("CloseSell", OBJPROP_CORNER, 1);
      ObjectSet ("CloseSell", OBJPROP_XDISTANCE, 10);
      ObjectSet ("CloseSell", OBJPROP_YDISTANCE, 95);
      }
   ObjectSetText ("CloseSell", "[CLOSE SELL]", 10, "Arial", Red);

   if (ObjectFind ("CloseSell") != -1 && ObjectGet ("CloseSell", OBJPROP_XDISTANCE)!= 10)
      {
      CloseSell();
      ObjectDelete ("CloseSell");
      }
/*
//---------- BUY ONLY BUTTON FUNCTION
   if (ObjectFind ("BuyOnly") == -1)
      {
      ObjectCreate ("BuyOnly", OBJ_LABEL, 0, 0, 0);
      ObjectSet ("BuyOnly", OBJPROP_CORNER, 1);
      ObjectSet ("BuyOnly", OBJPROP_XDISTANCE, 10);
      ObjectSet ("BuyOnly", OBJPROP_YDISTANCE, 95);}
      ObjectSetText ("BuyOnly", "[BUY ONLY]", 8, "Arial", CLR_NONE);

      if (ObjectFind ("BuyOnly") != -1 && ObjectGet ("BuyOnly", OBJPROP_XDISTANCE)!= 10)
         {
         ObjectDelete ("BuyOnly");
         if (BuyOnly)
            {
            GlobalVariableSet ("BuyOnly_" + MagicNo, 0);
            }
         else 
            {
            GlobalVariableSet ("BuyOnly_" + MagicNo, 1);
            }
         }

      if (GlobalVariableGet ("BuyOnly_" + MagicNo) == 1) BuyOnly = true;
      if (GlobalVariableGet ("BuyOnly_" + MagicNo) == 0) BuyOnly = false;

      if (BuyOnly) ObjectSetText ("BuyOnly", "[BUY ONLY]", 8, "Arial", Blue);
      if (!BuyOnly) ObjectSetText ("BuyOnly", "[BUY ONLY]", 8, "Arial", DarkGray);
      
//---------- SELL ONLY BUTTON FUNCTION
   if (ObjectFind ("SellOnly") == -1)
      {
      ObjectCreate ("SellOnly", OBJ_LABEL, 0, 0, 0);
      ObjectSet ("SellOnly", OBJPROP_CORNER, 1);
      ObjectSet ("SellOnly", OBJPROP_XDISTANCE, 10);
      ObjectSet ("SellOnly", OBJPROP_YDISTANCE, 105);}
      ObjectSetText ("SellOnly", "[SELL ONLY]", 8, "Arial", CLR_NONE);

      if (ObjectFind ("SellOnly") != -1 && ObjectGet ("SellOnly", OBJPROP_XDISTANCE)!= 10)
         {
         ObjectDelete ("SellOnly");
         if (SellOnly)
            {
            GlobalVariableSet ("SellOnly_" + MagicNo, 0);
            }
         else 
            {
            GlobalVariableSet ("SellOnly_" + MagicNo, 1);
            }
         }

      if (GlobalVariableGet ("SellOnly_" + MagicNo) == 1) SellOnly = true;
      if (GlobalVariableGet ("SellOnly_" + MagicNo) == 0) SellOnly = false;

      if (SellOnly) ObjectSetText ("SellOnly", "[SELL ONLY]", 8, "Arial", Red);
      if (!SellOnly) ObjectSetText ("SellOnly", "[SELL ONLY]", 8, "Arial", DarkGray);
      
//--------------------------------------------------------------------------------
      bool BuyOnly = false;
      bool SellOnly = false;
*/
//Money Management sequence
   if (MoneyManagement)
      {
      if (Risk < 0.1 || Risk > 100)
         {
         Alert ("Invalid Risk!");
         return(0);
         }
      }
//+------------------------------------------------------------------+
//| Variable Begin                                                   |
//+------------------------------------------------------------------+
// get value for Major TF Bar
   double   FilterBarOpen = iOpen (NULL, FilterBarTF, Current);
   double   SignalBarHigh = iHigh (NULL, SignalBarTF, 1);
   double   SignalBarLow = iLow (NULL, SignalBarTF, 1);
// trailing stop HiLo
   Spread      = NormalizeDouble (MarketInfo (Symbol(), MODE_SPREAD), Digits);
   SwapBuy     = NormalizeDouble (MarketInfo (Symbol(), MODE_SWAPLONG), Digits);
   SwapSell    = NormalizeDouble (MarketInfo (Symbol(), MODE_SWAPSHORT), Digits);
   TickValue   = NormalizeDouble (MarketInfo (Symbol(), MODE_TICKVALUE), Digits); // in deposit currency
// ----- Trailing High Low Stop Loss Calculation -----
   BuyTS       = iLow (NULL, TrailBarTF, iLowest (NULL, TrailBarTF, MODE_LOW, TrailBarsBack, 1)) - (TrailPipsFromHiLo * Point); // Long
   SellTS      = iHigh (NULL, TrailBarTF, iHighest (NULL, TrailBarTF, MODE_HIGH, TrailBarsBack, 1)) + (TrailPipsFromHiLo * Point); // Short
// ----- StopLoss High Low Calculation ---------   
   BuySL       = iLow (NULL, StopLossTF, iLowest (NULL, StopLossTF, MODE_LOW, StopLossBarsBack, 1)) - (StopLossPipsFromHiLo * Point); // Long
   SellSL      = iHigh (NULL, StopLossTF, iHighest (NULL, StopLossTF, MODE_HIGH, StopLossBarsBack, 1)) + (StopLossPipsFromHiLo * Point); // Short
//+------------------------------------------------------------------+
//| Variable End                                                     |
//+------------------------------------------------------------------+
//--------------------------
   int Order = SIGNAL_NONE;
   int Total, Ticket;
//   static int MaxTrades;

   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
// ======================================
//Check position
   for (int i = 0; i < Total; i ++) 
      {
      OrderSelect (i, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() <= OP_SELL &&  OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNo)
         {
         if (OrderType() == OP_BUY) 
            {
//MoveOnce
            if (MoveStopOnce && MoveStopWhenPrice > 0) 
               {
               if (Bid - OrderOpenPrice() >= Point * MoveStopWhenPrice)
                  {
                  if (OrderStopLoss() < OrderOpenPrice() + Point * MoveStopTo)
                     {
                     OrderModify (OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + Point * MoveStopTo, OrderTakeProfit(), 0, Red);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                     }
                  }
               }
//Trailing stop
            if (UseTrailHiLoStop)
               {
               if (BuyTS > OrderStopLoss() || OrderStopLoss() == 0)
                  {
                  OrderModify (OrderTicket(), 0, BuyTS,0, 0, Blue);
                  if (!EachTickMode) BarCount = Bars;
                  continue;
                  }
               }
            } 
         if (OrderType() == OP_SELL)
            {
//MoveOnce
            if (MoveStopOnce && MoveStopWhenPrice > 0)
               {
               if (OrderOpenPrice() - Ask >= Point * MoveStopWhenPrice)
                  {
                  if (OrderStopLoss() > OrderOpenPrice() - Point * MoveStopTo)
                     {
                     OrderModify (OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - Point * MoveStopTo, OrderTakeProfit(), 0, Red);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                     }
                  }
               }
//Trailing stop
            if (UseTrailHiLoStop)
               {
               if (SellTS < OrderStopLoss() || OrderStopLoss() == 0)
                  {
                  OrderModify (OrderTicket(), 0, SellTS, 0, 0, Blue);
                  if (!EachTickMode) BarCount = Bars;
                  continue;
                  }
               }
            }
         }
      }
//+------------------------------------------------------------------+
//| Signal Begin(Entry)                                              |
//+------------------------------------------------------------------+
// BUY
      if (
         (Hour() >= StartTrading && Hour() < StopTrading)
         &&
         (Ask > SignalBarHigh)
         &&
         (Ask > FilterBarOpen)
//         &&
//         (!SellOnly)
         )
         Order = SIGNAL_BUY;
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++      
// SELL
      if (
         (Hour() >= StartTrading && Hour() < StopTrading)
         &&
         (Bid < SignalBarLow)
         &&
         (Bid < FilterBarOpen)
//         &&
//         (!BuyOnly)
         )
         Order = SIGNAL_SELL;
//+------------------------------------------------------------------+
//| Signal End                                                       |
//+------------------------------------------------------------------+
//Buy
      if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))))
         {
         if (SignalsOnly)
            {
//------ Alert Should be only once per signal OR once every 15 or 30 Minute
            if (CheckAlertTime == iTime (NULL, 5, 0)) return(0);
            else CheckAlertTime = iTime (NULL, 5, 0);
            if (Alerts) Alert (Symbol() + " " + DoubleToStr (Ask, Digits) + " BUY Signal");
            if (PlaySounds) PlaySound (WhichSound);
            }
         if (/*!IsTrade && */!SignalsOnly)
            {
            if (CheckAlertTime == iTime (NULL, OncePerBarTF, 0)) return(0);
            else CheckAlertTime = iTime (NULL, OncePerBarTF, 0);
//---------- Check free margin
            if (AccountFreeMargin() < (1000 * Lots))
               {
               Print ("We have no money. Free Margin = ", AccountFreeMargin());
               return(0);
               }

            if (MoneyManagement) Lots = NormalizeDouble ((AccountFreeMargin() * Risk / 100 / ((Ask - BuySL) / Point / TickValue)), 2);
            else Lots = Lots;

            RefreshRates();

            Ticket = OrderSend (Symbol(), OP_BUY, MathAbs (Lots), Ask, Slippage, BuySL, 0, "7Chi Buy " + Symbol(), MagicNo, 0, DodgerBlue);
            if (Ticket > 0) 
               {
               if (OrderSelect (Ticket, SELECT_BY_TICKET, MODE_TRADES))
                  {
                  Print ("7Chi BUY opened: ", OrderOpenPrice());
   			      if (Alerts) Alert (Symbol() + " " + DoubleToStr (Ask, Digits) + " BUY signal");
                  if (PlaySounds) PlaySound (WhichSound);
			         }
			      else
			         {
                  Print ("Error opening BUY: ", Err);
			         }
               }
            if (EachTickMode) TickCheck = True;
            if (!EachTickMode) BarCount = Bars;
            return(0);
            }
         }
//Sell
      if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))))
         {
         if (SignalsOnly)
            {
// ------ Alert Should be only once per signal OR once every 15 or 30 Minute
            if (CheckAlertTime == iTime (NULL, 5, 0)) return(0);
            else CheckAlertTime = iTime (NULL, 5, 0);
            if (Alerts) Alert (Symbol() + " " + DoubleToStr (Bid, Digits) + " SELL Signal");
            if (PlaySounds) PlaySound (WhichSound);
            }
         if (/*!IsTrade && */!SignalsOnly)
            {
            if (CheckAlertTime == iTime (NULL, OncePerBarTF, 0)) return(0);
            else CheckAlertTime = iTime (NULL, OncePerBarTF, 0);
//---------- Check free margin
            if (AccountFreeMargin() < (1000 * Lots))
               {
               Print ("We have no money. Free Margin = ", AccountFreeMargin());
               return(0);
               }
            if (MoneyManagement) Lots = NormalizeDouble ((AccountFreeMargin() * Risk / 100 / ((SellSL - Bid) / Point / TickValue)), 2);
            else Lots = Lots;
//----------------- 
            RefreshRates();
//-----------------     
            Ticket = OrderSend (Symbol(), OP_SELL, MathAbs (Lots), Bid, Slippage, SellSL, 0, "7Chi Sell " + Symbol(), MagicNo, 0, DeepPink);
            if (Ticket > 0)
               {
               if (OrderSelect (Ticket, SELECT_BY_TICKET, MODE_TRADES))
                  {
                  Print ("7Chi SELL opened: ", OrderOpenPrice());
                  if (Alerts) Alert (Symbol() + " " + DoubleToStr (Bid, Digits) + " SELL signal");
                  if (PlaySounds) PlaySound (WhichSound);
			         }
			      else
			         {
                  Print ("Error opening SELL: ", Err);
                  }
               }
            if (EachTickMode) TickCheck = True;
            if (!EachTickMode) BarCount = Bars;
            return(0);
            }
         }
      if (!EachTickMode) BarCount = Bars;
      return(0);
      }
//-----  BOOLEAN VARIABLE TO STRING FUNCTION
string BoolToStr (bool Value)
   {
   if (Value == true) return ("True");
   else return ("False");
   }
//-----  BOOLEAN VARIABLE TO STRING FUNCTION No.2
string BoolToStr2 (bool Value)
   {
   if (Value == true) return ("TRUE");
   else return ("FALSE !!!");
   }
//----- BOOLEAN VARIABLE TO INTEGER FUNCTION ----- ????
int BoolToInt (int Value)
   {
   if (Value == true) return (1);
   else return (0);
   }
// calculate unrealized P&L, belonging to all open trades with this magic number
double GetProfit (int MagicNo)
   {
   int cnt;
   double Profit = 0;
   int total = OrdersTotal();
   for (cnt = 0; cnt < total; cnt ++)
      {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == MagicNo)
         {
         Profit += OrderProfit() + OrderSwap() + OrderCommission();
         }
      }
   return (Profit);
   }
// calculate CLOSED PROFIT for this magic number
double GetClosedProfit (int MagicNo)
   {
   int cnt;
   double ProfitClosed = 0;
   int total = OrdersHistoryTotal();
   for (cnt = 0; cnt < total; cnt ++)
      {
      OrderSelect (cnt, SELECT_BY_POS, MODE_HISTORY);
      if (OrderMagicNumber() == MagicNo)
         {
         ProfitClosed += OrderProfit() + OrderSwap() + OrderCommission();
         }
      }
   return (ProfitClosed);
   if (!GlobalVariableCheck ("ClosedProfit_" + Symbol())) GlobalVariableSet (("ClosedProfit_" + Symbol()), ProfitClosed);
   }
//------- CLOSE ALL FUNCTION - needs loop to close all
int CloseAll()
   {
   int total = OrdersTotal();
   for (int i = total - 1; i >= 0; i --)
      {
      OrderSelect (i, SELECT_BY_POS);
      int type = OrderType();
      bool result = false;
      if (OrderMagicNumber() == MagicNo)
         {
         switch(type)
            {
//Close opened long positions
            case OP_BUY: result = OrderClose (OrderTicket(), OrderLots(), MarketInfo (OrderSymbol(), MODE_BID), 5, Red);
            break;
//Close opened short positions
            case OP_SELL: result = OrderClose (OrderTicket(), OrderLots(), MarketInfo (OrderSymbol(), MODE_ASK), 5, Red );
            break;
            }
         }
      if (OrderMagicNumber() == MagicNo && result == false)
         {
         Alert ("Order ", OrderTicket(), " failed to close. Error:" , GetLastError());
         Sleep (500);
         }  
      }
   GlobalVariableSet ("SignalsOnly_" + Symbol(), 1); //SignalsOnly = true;
   return (0);
   }
//------- CLOSE BUY FUNCTION - needs loop to close all --- MagicNO ???
int CloseBuy()
   {
   int total = OrdersTotal();
   for (int i = total - 1; i >= 0; i --)
      {
      OrderSelect (i, SELECT_BY_POS);
      int type = OrderType();
      bool result = false;
      if (OrderMagicNumber() == MagicNo)
         {
         switch(type)
            {
//Close opened long positions
            case OP_BUY: result = OrderClose (OrderTicket(), OrderLots(), MarketInfo (OrderSymbol(), MODE_BID), 5, Red);
            break;
            }
         }
      if (OrderMagicNumber() == MagicNo && result == false)
         {
         Alert ("Order ", OrderTicket(), " failed to close. Error:" , GetLastError());
         Sleep (500);
         }  
      }
   GlobalVariableSet ("SignalsOnly_" + Symbol(), 1); //SignalsOnly = true;
   return (0);
   }
//------- CLOSE SELL FUNCTION - needs loop to close all
int CloseSell()
   {
   int total = OrdersTotal();
   for (int i = total - 1; i >= 0; i --)
      {
      OrderSelect (i, SELECT_BY_POS);
      int type = OrderType();
      bool result = false;
      if (OrderMagicNumber() == MagicNo)
         {
         switch(type)
            {
//Close opened short positions
            case OP_SELL: result = OrderClose (OrderTicket(), OrderLots(), MarketInfo (OrderSymbol(), MODE_ASK), 5, Red );
            break;
            }
         }
      if (result == false)
         {
         Alert ("Order ", OrderTicket(), " failed to close. Error:" , GetLastError());
         Sleep (500);
         }  
      }
   GlobalVariableSet ("SignalsOnly_" + Symbol(), 1); //SignalsOnly = true;
   return (0);
   }
//--------- CHECK LINE CROSSING FUNCTION
void checkLines()
   {
   if (crossedLine ("close all"))
      {
      CloseAll();
      }
   if (crossedLine ("close buy"))
      {
      CloseBuy();
      }
   if (crossedLine ("close sell"))
      {
      CloseSell();
      }
   if (crossedLine ("trade"))
      {
      GlobalVariableSet ("SignalsOnly_" + Symbol(), 0); // signals only = false, trade
      }
   }
//--------------------------------------------------------------------------------------------
void CheckMaxTrades()
   {
   int Trade = MaxTrades;
   int Total = OrdersTotal();
   bool ContinueTrading;
   for (int i = 0; i < Total; i ++)
      {
      OrderSelect (i, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() <= OP_SELL &&  OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNo)
         {   
         if (Total >= Trade)
            {
            GlobalVariableSet ("SignalsOnly_" + Symbol(), 1); // SignalsOnly = True; //stop trading
            }
         if (Total < Trade && ContinueTrading)
            {
            GlobalVariableSet ("SignalsOnly_" + Symbol(), 0); //  SignalsOnly = false;
            }
         }
      }
   }
//--------------------------------------------------------------------------

